<cfsilent>
<!--- -->
<?xml version="1.0" encoding="UTF-8"?>
<fusedoc language="ColdFusion" FUSE="calc.cfm" Specification="2.0">
	<responsibilities>
			I receive an XML Packet via an HTTP call.  I then call an XML Parser and 
			deserialize the WDDX packet that is returned and retrieve the values needed
			for the calculator.
			
			I calculate the results and place the information out in an XML Format for the
			calling program to retrieve.
	</responsibilities> 
	<properties>
		<property 	name="Version" value="1.0" />
		<property	name="copyright" value="2001, Shayna Productions, all rights reserved." />
		<history 	author="Sandra Clark" email="slclark@shayna.com" type="Create" date="" 
					role="Architect"></history>
					
		<note author="Sandra Clark" date="2/8/2002">
			XML coming in is in this form.
			
			<calculation>
				<firstNumber>#number#</firstNumber>
				<secondNumber>#number#</secondNumber>
				<operand>#string#</operand>
			</calculation>
			
			XML To be returned is in this form.
			<calculation>
				<results>#calcresult#</results>
			</calculation>
			
			Note: There is no white space in either of these xml packets.
		</note>
	</properties>
	<assertions>
		
	</assertions>
	<io>
		<in>
			<String name="xmlpacket" Scope="Variables" Optional="False" format="XML" 
					comments="xml packet coming from the calling program"/>
			<string name="type" scope="url" comments="what front end type this is coming from.">
		</in>
		<out>
			<string name="xmlsend" scope="variables" optional="false" format="XML"
				comments="xml packet to return to calling program.  Take out all extra spaces">		
		</out>
	</io>
</fusedoc>
--->
</cfsilent>
<cfsetting showdebugoutput="No">	<!--- Necessary if debugging is turned on your machine, xtra info confuses calling program on data return. --->
<cfsilent>							<!--- Keep all extraneous white space to minimum. --->


<cfset xmlpacket= GetHttpRequestData() > <!--- Receive data from calling program. --->

<!--- If its coming from html front end, get rid of xmlstring= attribute --->
<cfif Not CompareNoCase(url.type,'html')>
	<cfset xmlpacket.content = urldecode(replacenocase(xmlpacket.content,"xmlstring=",""))>
</cfif>
<!--- For debugging purposes only.  Since none of this goes to a browser, write information to a text file --->
<cffile action="Write" file="G:\InetPub\WWWROOT\test\calculator\calcoutput.txt" output="#xmlpacket.content#" addnewline="Yes">

<!--- Parse XML using CFDev's XML Parser have it return in WDDX format. --->
<CFX_XMLParser xml="#xmlpacket.content#" output="wddx"> 

<!--- Deserialize WDDX XML Packet --->
<cfwddx action="WDDX2CFML" input="#wddx#" output="root">


<cfscript>
	// Parse through document and place in variables for easy processing.
	FirstNum = root.calculation.firstNumber.Inner_Text;
	SecondNum = root.calculation.secondNumber.Inner_Text;
	Operand = root.calculation.operand.inner_text;
	// Make sure to check for Divide by Zero 
	if (Not CompareNoCase(operand, "/") AND SecondNum eq 0){
		SecondNum = 1;
	}
	
	// Perform actual calculation.
	result = evaluate("#FirstNum# #operand# #SecondNum#")	;
</cfscript> 
<!--- Create XML Output --->
<cfset xmlsend = "<calculation><results>#result#</results></calculation>">
<!--- Debugging information --->
<cffile action="APPEND" file="G:\InetPub\WWWROOT\test\calculator\calcoutput.txt" output="#xmlsend#" addnewline="Yes">

<!--- When outputting information (which calling program will pick up, make sure extra spaces are removed. --->
</cfsilent>
<cfoutput>#rereplace(xmlsend,">[[:space:]]>","")#</cfoutput>