<cfsilent>
<!--- -->
<?xml version="1.0" encoding="UTF-8"?>
<fusedoc language="ColdFusion" FUSE="retrievecalc.cfm" Specification="2.0">
	<responsibilities>
		I take the information passed to me by the display page, create an XML
		packet in the correct format and then send it to the calculator on the back end.
		When I receive the results back I extract them from the xml and call the display page.
	</responsibilities> 
	<properties>
		<history 	author="Sandra Clark" email="slclark@shayna.com" type="Create" date="" 
					role="Architect"></history>
	</properties>
		<note author="Sandra Clark" date="2/8/2002">
			XML to be sent in this form.
			
			<calculation>
				<firstNumber>#number#</firstNumber>
				<secondNumber>#number#</secondNumber>
				<operand>#string#</operand>
			</calculation>
			
			XML returnd in this form.
			<calculation>
				<results>#calcresult#</results>
			</calculation>
			
			Note: There is no white space in either of these xml packets.
		</note>
	<io>
		<in>
			<number name="First" precision="Decimal" scope="formOrUrl" optional="False" 
					comments="First Number for Calculation"/>
			<number name="Second" precision="Decimal" scope="formOrUrl" optional="False" 
					comments="Second Number for Calculation"/>
			<string 
					name="operand" scope="formOrUrl" optional="False" 
					comments="Operand for Calculation"/>
		</in>
		<out>
			<String name="xmlstring" Scope="Variables" Optional="False" format="XML" 
				comments="xml string sent to calculation program"/>
			<string name="type" scope="url" comments="Set to HTML to denote calling program."/>
			<number name="calcresults" precision="Decimal" comments="Results received from calling program"/>
		</out>
	</io>
</fusedoc>
--->
<cfscript>
// Used to make this template server and path independant.

	request.site.root="#cgi.server_name#";
	tempScriptName=ReplaceNoCase(cgi.script_name, "/", "" );
	
	// Site Structure contains Paths and roots for urls.
	path=REReplaceNoCase(tempScriptName, "/retrievecalc.cfm", "");
	
	if(Not compareNoCase(right(path,1),"/")){
		truelength = len(path) - 1;
		path=left(path,truelength);
	}

	
	//  Main Web Root 
	// Root is http based for Javascript, <a href's, image and cflocation calls.
	request.site.WebRoot="http://#request.site.Root#/#path#";


	//Build XML String with variables returned from form.--->

	xmlString ="<calculation><firstNumber>#form.first#</firstNumber>";
   	xmlString = xmlString&"<secondNumber>#form.second#</secondNumber>";
   	xmlString = xmlString&"<operand>#form.operand#</operand></calculation>";
</cfscript>

<!--- Send Via CFHTTP to coldfusion Page, get results --->
<cftry>
<cfset success = true>
<cfhttp url="#request.site.WebRoot#/calc.cfm?type=html" method="POST" resolveurl="false">
	<cfhttpparam type="FORMFIELD" name="xmlstring" value="#xmlstring#">
</cfhttp>
<cfcatch>
	<cfset success = false>
	<cfset calcresults = "0">
</cfcatch>
</cftry>
<cfif success>
<CFX_XMLParser xml="#cfhttp.fileContent#" output="wddx"> 
<cfwddx action="WDDX2CFML" input="#wddx#" output="root">

<!--- Set up variable with actual results from calculation XML --->
<cfscript>
	calcresults = trim(root.calculation.results.Inner_Text);
</cfscript> 
</cfif>
<!--- Call display back with results. --->
<cflocation url="#request.site.WebRoot#/dspcalc.cfm?results=#calcresults#">

</cfsilent>